
# Contributing to Countly

Countly is a big project benefiting from plugin support to make contributions easy, and we are happy to receive contributors with different skills: 

* If you know Javascript and HTML5/CSS you can contribute to core layer and user interface of Countly. 
* If you know MongoDB and NodeJS, you can contribute to database layer. 
* If you know Java, you can contribute to [Countly Android SDK](https://github.com/countly/countly-sdk-android). 
* If you know Objective-C, you can contribute to [Countly iOS SDK](https://github.com/countly/countly-sdk-ios). 
* If you know any other language, you can start writing your own SDK and help others use Countly as a backend. 
[Here's a list of SDKs that Countly supports](https://support.count.ly/hc/en-us/articles/360037236571-Downloading-and-Installing-SDKs).

## Contribution areas 

You can always send a pull request to Countly Lite or to Countly SDKs for the following: 

* New features, small or big, including installation, integration, tests, user interface, user experience, extra platforms and such.  
* Bugfixes (excluding translations, explained below) 
* Inefficient code
* Documentation (including installation, deployment to various platforms, video training) 

Before sending a pull request, we expect you first check 
[all new issues](https://github.com/countly/countly-server/issues/) before putting your effort. It's also better to 
test your code thoroughly before sending it over. Also please check existing code to have an understanding of how we work. 

Before starting, you may want to check Github's guide on [contributing open source projects](https://guides.github.com/activities/contributing-to-open-source/).

## Translations

All translations take place on [Transifex Countly page](https://explore.transifex.com/osoner/countly/). Please check if your language 
is not there, or has a small percentage of translation. Create your account and apply to be a translator. 

## Setting up a Development Environment

Whether you want to start working on developing a new plugin, or some feature/issue on the Countly Server itself, you will need a development environment to test your code on. 

1. [You can install Countly on server/VM running Ubuntu](https://support.count.ly/hc/en-us/articles/360037443652-Upgrading-the-Countly-Server)

2. [You can use Docker containers](https://support.count.ly/hc/en-us/articles/360037814511-Docker-and-Kubernetes)